using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Script.Serialization;
using System.Xml;

public partial class mega_sys_info : System.Web.UI.Page
{

  MEGAWebAccessLib.MegaWebAccess m_pMWA = null;
  Settings m_pSettings = null;
  protected bool m_bReportDumped = false;
  

  protected void Page_Load(object sender, EventArgs e)
  {
    if (Request.QueryString["complete"] != null)
    {
      DumpReport( "&lt;skipped&gt;" );
    } 
    else if (Request.Form["complete"] != null) 
    {
      String szClientData = FormatClientData(Request.Form["resJson"]);      
      DumpReport(szClientData);
    }    
  }

  protected string FormatClientData( string szJsonData ) {
    var jss = new JavaScriptSerializer();
    var sb = new StringBuilder();
    var results = (Dictionary<string, object>) jss.DeserializeObject(szJsonData);
    foreach (var category in results) {
      sb.Append("<h2>");
      sb.Append(Server.HtmlEncode(category.Key));
      sb.Append("</h2>");
      sb.Append("<table><tbody>");
      var tbTests = (object[])category.Value;
      foreach (Dictionary<string, object> test in tbTests) {
        sb.Append("<tr><th>");
        sb.Append( test["title"] );
        sb.Append("</th><td>");
        sb.Append( test["res"] );
        sb.Append("</td><td>");
        sb.Append( test["bOk"] );
        sb.Append("</td></tr>");
      }
      sb.Append("</tbody></table>");          
    }
    return sb.ToString();
  }

  private void DumpReport(string szClientData) {
    m_bReportDumped = true;
    Utilities.initializePage(Application, ref m_pMWA, ref m_pSettings);
    Response.AddHeader("Content-Disposition", "attachment; filename=MEGASystemWebReport.html");

    Response.Write("<html><head></head><body>");

    Response.Write("<h1>Client System Information</h1>");
    Response.Write(szClientData);

    Response.Write("<h1>Mega System Information</h1>");
    Response.Write("<pre>");
    
    Object oTypeStat = null;
    string sSysInfo = "";
    sSysInfo = m_pMWA.CallService("MegaSystemInformation", "", "", "", ref oTypeStat);
    Response.Write(Server.HtmlEncode(sSysInfo));
    Response.Write("</pre>");

    
    Response.Write("<h1>MWAS System Information</h1>");

    Response.Write("<h2>Generation Context</h2>");
    Response.Write("<pre>");

    try
    {
      StringWriter stringWriter = new StringWriter();
      XmlDocument doc = new XmlDocument();
      doc.LoadXml(m_pSettings.genContext);
      XmlNodeReader xmlReader = new XmlNodeReader(doc);
      XmlTextWriter xmlWriter = new XmlTextWriter(stringWriter);
      xmlWriter.Formatting = Formatting.Indented;
      xmlWriter.Indentation = 4;
      xmlWriter.IndentChar = ' ';
      xmlWriter.WriteNode(xmlReader, true);
      Response.Write(Server.HtmlEncode(stringWriter.ToString()));
    }
    catch (Exception eGenCtx)
    {
      Response.Write(eGenCtx.Message);
      Response.Write("\r\nGenContext:" + m_pSettings.genContext);
    }

    Response.Write("</pre>");

    Response.Write("<h2>Log</h2>");
    string szLogPath = System.Web.Configuration.WebConfigurationManager.AppSettings["LogFileName"];
    DateTime now = DateTime.Now;
    string szNow = now.ToString("MM-dd-yy");
    szLogPath = szLogPath.Replace(".TXT", szNow + ".TXT");
    if (File.Exists(szLogPath))
    {
      string szLog = "";
      try
      {
        StreamReader pReader = new StreamReader(szLogPath);
        String sLine = pReader.ReadLine();
        while (sLine != null)
        {
          szLog += sLine;
          if (sLine.Length > 0) szLog += "\n";
          sLine = pReader.ReadLine();
        }
      }
      catch (System.Exception eRead)
      {
        System.Console.Write(eRead.Message);
        Response.Write("<pre>" + eRead.Message + "</pre>");
      }
      Response.Write("<pre>" + Server.HtmlEncode(szLog) + "</pre>");
    }
    else
    {
      Response.Write("Not found.");
    }
    
    Response.Write("<h1>IIS System Information</h1>");

    // Browser version
    System.Web.HttpBrowserCapabilities browser = Request.Browser;
    string sBrowserCap = "<h2>HttpBrowserCapabilities</h2>"
        + "Type = " + browser.Type + "<br/>"
        + "Name = " + browser.Browser + "<br/>"
        + "Version = " + browser.Version + "<br/>"
        + "Major Version = " + browser.MajorVersion + "<br/>"
        + "Minor Version = " + browser.MinorVersion + "<br/>"
        + "Platform = " + browser.Platform + "<br/>"
        + "Is Beta = " + browser.Beta + "<br/>"
        + "Is Crawler = " + browser.Crawler + "<br/>"
        + "Is AOL = " + browser.AOL + "<br/>"
        + "Is Win16 = " + browser.Win16 + "<br/>"
        + "Is Win32 = " + browser.Win32 + "<br/>"
        + "Supports Frames = " + browser.Frames + "<br/>"
        + "Supports Tables = " + browser.Tables + "<br/>"
        + "Supports Cookies = " + browser.Cookies + "<br/>"
        + "Supports VBScript = " + browser.VBScript + "<br/>"
        + "Supports JavaScript = " +
            browser.EcmaScriptVersion.ToString() + "<br/>"
        + "Supports Java Applets = " + browser.JavaApplets + "<br/>"
        + "Supports ActiveX Controls = " + browser.ActiveXControls
              + "<br/><br/>";
    Response.Write(sBrowserCap);

    Response.Write("<h2>inetinfo.exe</h2>");
    try
    {
      System.Diagnostics.FileVersionInfo verinfo = System.Diagnostics.FileVersionInfo.GetVersionInfo(System.Environment.SystemDirectory + "\\inetsrv\\inetinfo.exe");
      Response.Write("Version = " + verinfo.FileMajorPart + " (" + verinfo.FileVersion + ")<br/><br/>");
    }
    catch (Exception exc)
    {
      Response.Write(exc);
    }
  }
	  
}
