(function(){

  function showPleaseWait() {
    var forceLink = dojo.byId('forceLink');
    forceLink.style.visibility = 'hidden';
    var forceLink = dojo.byId('pleaseWait');
    forceLink.style.visibility = 'visible';
  }

  Ext.onReady(function() {
    Ext.BLANK_IMAGE_URL = '../<%=settings.PATH_EXTJS%>/resources/images/default/s.gif';
    dojo.addOnLoad( function() {

      var oResults = {};

      function appendTr( tbl, title, res, unit, bOk ) {
        var tr = document.createElement( 'tr' );
        var th = document.createElement( 'th' );
        var thTxt = document.createTextNode( title );
        th.appendChild( thTxt );
        var td = document.createElement( 'td' );
        var formattedRes = res + (unit || '');
        var tdTxt = document.createTextNode( formattedRes );
        td.appendChild( tdTxt );
        var td2 = document.createElement( 'td' );
        dojo.addClass( td2, (bOk ? 'ok' : 'failed' ) );
        var formattedBOk = ( bOk ? 'OK' : 'XX' );
        var tdTxt2 = document.createTextNode( formattedBOk );
        td2.appendChild( tdTxt2 );
        tr.appendChild( th );
        tr.appendChild( td );
        tr.appendChild( td2 );
        tbl.appendChild( tr );

        var idCateg = tbl.id;
        if (! oResults[idCateg]) {
          oResults[idCateg] = [];
        }
        oResults[idCateg].push( {
          title : Ext.String.htmlEncode(title),
          res   : Ext.String.htmlEncode(formattedRes),
          bOk   : Ext.String.htmlEncode(formattedBOk)
        } );
      }

      function postData() {
        showPleaseWait();
        var resPoster = dojo.byId('resPoster');
        resPoster.elements['resJson'].value = JSON.stringify(oResults);
        resPoster.submit();
      }

      // Browser Detection
      var userAgent = dojo.byId('useragent');
      userAgent.innerHTML = navigator.userAgent.toLowerCase();
      var browserTable = dojo.byId('browser');
      var bOk = false;
      var szBrowser = '<unsupported>';
      if (dojo.isFF) {
        szBrowser = 'Firefox ' + dojo.isFF;
        bOk = dojo.isFF >= cfg.minFF;
      } else if (dojo.isIE) {
        szBrowser = 'Internet Explorer ' + dojo.isIE;
        bOk = (dojo.isIE >= cfg.minIE) && (dojo.isIE <= cfg.minIE);
      }else if (dojo.isChrome) {
        szBrowser = 'Chrome ' + dojo.isChrome;
        bOk = true;
      }else if (dojo.isSafari) {
        szBrowser = 'Safari ' + dojo.isSafari;
        bOk = dojo.isSafari >= cfg.minSafari;
      }
      appendTr( browserTable, 'Dojo detection ', szBrowser, '', bOk );

      bOk = false;
      szBrowser = '<unsupported>';
      if (Ext.isGecko) {
        var iVerFF = cfg.minExtFF;
        while ( Ext['isGecko'+iVerFF] === false ) {
          iVerFF++;
        }
        szBrowser = 'Firefox ' + (Ext['isGecko'+iVerFF] ? iVerFF : '<unknown>');
        bOk = iVerFF >= cfg.minFF;
      } else if (Ext.isIE) {
        var iVerIE = cfg.minExtIE;
        while ( Ext['isIE'+iVerIE] === false ) {
          iVerIE++;
        }
        if (!Ext['isIE'+iVerIE]){
          iVerIE = -1;
        }
        szBrowser = 'Internet Explorer '  + (Ext['isIE'+iVerIE] ? iVerIE : '<unknown>');
        bOk = (iVerIE >= cfg.minIE) && (iVerIE <= cfg.minIE);
      } else if (Ext.isChrome) {
        szBrowser = 'Chrome ';
        bOk = true;
      }else if (Ext.isSafari) {
        szBrowser = 'Safari ';
        bOk = ((!Ext.isSafari2) && (!Ext.isSafari3) && (!Ext.isSafari4));
      }
      appendTr( browserTable, 'ExtJs detection ', szBrowser, '', bOk );

      var bIE8CompatView = ( dojo.isIE == 8 && Ext.isIE && Ext.isIE7 ) || ( dojo.isIE == 9 && Ext.isIE && Ext.isIE7 );
      appendTr( browserTable, 'IE8 Compatibilty View', bIE8CompatView, '', !bIE8CompatView );

      appendTr( browserTable, 'Firebug ', console.firebug, '', !console.firebug );

      var flashVer = swfobject.getFlashPlayerVersion();
      var bFlashVerOk = (     flashVer.major >  cfg.minFlash.major
      || (flashVer.major == cfg.minFlash.major && flashVer.minor >  cfg.minFlash.minor)
      || (flashVer.major == cfg.minFlash.major && flashVer.minor == cfg.minFlash.minor && flashVer.release >= cfg.minFlash.release) );
      appendTr( browserTable, 'Flash ', flashVer.major+'.'+flashVer.minor+'.'+flashVer.release, '', bFlashVerOk );
      swfobject.embedSWF("404.swf", "flashDetect", "100%", "100%", cfg.minFlash.major+'.'+cfg.minFlash.minor+'.'+cfg.minFlash.release,
        false, null, null, null, function(e) {
          appendTr( browserTable, 'Flash embedding', '', '', e.success );
        });

      // Window size
      var win = window.opener;
      if (win) {
        var szClientSize;
        if (win.innerWidth) {
          szClientSize = win.innerWidth + ' x ' + win.innerHeight;
        } else if (win.document.documentElement.clientHeight) {
          szClientSize = win.document.documentElement.clientWidth + ' x ' + win.document.documentElement.clientHeight;
        }
      }
      appendTr( browserTable, 'Client size ', szClientSize, '', win && szClientSize );

      // Ping
      var pingTable = dojo.byId('ping');
      var ts = new Date();
      var tPing = [];
      var tAll = 0;
      var tPingStart = new Date();

      function launchPing(i) {
        var szUrl = cfg.pingUrl+ ++ts;
        tPing[i] = new Date();
        var bOk = false;
        dojo.xhrGet({
          url: szUrl,
          handleAs: 'text',
          sync: i%2==0,
          handle: function(response) {
            tPing[i] = (new Date() - tPing[i]);
            tAll += tPing[i];
            var bOk = (-1 != response.indexOf( cfg.pingResponse ) );
            appendTr( pingTable, 'Ping ' + i + (i%2==0?' (sync)':''), (bOk ? tPing[i] : '<error>'), ' ms',  bOk && (tPing[i]<cfg.maxPing) );
            if (i<cfg.nbPing) {
              launchPing(i+1);
            } else {
              pingCompleted();
            }
          }
        });
      }
      launchPing(1);

      function pingCompleted() {
        var tPingEnd = new Date();
        appendTr( pingTable, 'Average', tAll / cfg.nbPing, ' ms', tAll / cfg.nbPing < cfg.maxPing );
        appendTr( pingTable, 'Total', tPingEnd-tPingStart, ' ms', tPingEnd-tPingStart < cfg.maxPing*cfg.nbPing );


        // Bandwith
        var bandTable = dojo.byId('bandwith');
//              while (nextIter != -1 && nextIter<cfg.tbBandwidthIter.length) {
        function launchBandwith(nextIter) {
          if (nextIter != -1 && nextIter < cfg.tbBandwidthIter.length) {
            var szUrl = 'bandwidth.aspx?iter='+cfg.tbBandwidthIter[nextIter]+'&'+ ++ts;
            var tBandwidthStart = new Date();
            dojo.xhrGet({ url: szUrl,
              handleAs: 'text',
              timeout: 60000,
              load: function(res) {
                var tBandwidthEnd = new Date();
                var tTime = (tBandwidthEnd-tBandwidthStart);
                var kBps = 8*res.length/(1.024*tTime);
                appendTr( bandTable, Math.round(8*res.length/1024,2) + ' kb in ' + tTime + ' ms',
                  Math.round(kBps,2), ' kb/s', kBps>cfg.minkBps );

                if (tTime < 2000) {
                  launchBandwith(nextIter+1);
                } else {
                  launchBandwith(-1);
                }
              },
              error: function(err) {
                appendTr( bandTable, 'Error', '', err, false );
                launchBandwith(-1);
              }
            });
          } else {
            postData();
          }
        }
        launchBandwith(0);
      }

    });
  });

})();